package mybatis.main;

import java.io.IOException;
import java.io.Reader;
import java.util.List;

import org.apache.ibatis.io.Resources;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.apache.ibatis.session.SqlSessionFactoryBuilder;

import mybatis.mapper.StudentMapper;
import mybatis.mapper.entity.Student;

public class MainTest {
    public static void main(String[] args) throws IOException {
        Reader reader = Resources.getResourceAsReader("SqlMapConfig.xml");
        SqlSessionFactory sqlSessionFactory = new SqlSessionFactoryBuilder().build(reader);
        SqlSession session = sqlSessionFactory.openSession();
        
        // get student mapper
        StudentMapper studentMapper = session.getMapper(StudentMapper.class);
        
        Student student = new Student();
        student.setName("%Jim%");

        // test if statement
        List<Student> litStudents = studentMapper.getStudentByName_Id(student);
        System.out.println(litStudents.size());
        
        // test choose, when statement
        litStudents = studentMapper.getStudentByName_Id_phone(student);
        System.out.println(litStudents.size());
        
        // test where statement
        litStudents = studentMapper.getStudentByName_Id_Where(student);
        System.out.println(litStudents.size());        

        // close session
        session.close();
    }
}
